// juego.c
// Esqueleto de juegos de Radastan para ZX Spectrum
// version 0.1 beta

#include <sprites.h>
#include <tiles.h>
#include <tiles_menu.h>
#include <final.h>
#include <numeros.h>
#include <lib\motor.h>
#include <lib\sonidos.h>
#include <mapa.h>
#include <marco.h>

extern unsigned char pantalla [768] @ 30000;
extern unsigned char anim @ 29999;
extern unsigned char x @ 29997; // Posicin personaje
extern unsigned char y @ 29996;
extern unsigned char ux @ 29995; // Posicin personaje al entrar en una pantalla
extern unsigned char uy @ 29994;
extern unsigned char vidas @ 29993;
extern unsigned char ene1_dir @ 29992;
extern unsigned char ene2_dir @ 29991;
extern unsigned char anime @ 29990;
extern unsigned char ene1_x @ 29989;
extern unsigned char ene1_y @ 29988;
extern unsigned char ene2_x @ 29987;
extern unsigned char ene2_y @ 29986;
extern unsigned int sala @ 29982;
extern unsigned char izquierda @ 29981;
extern unsigned char frame @ 29980;
extern unsigned char recoger @ 29979;
extern unsigned char llaves @ 29978;
extern unsigned char mapa_joyas [48] @ 29930;
extern unsigned int sala2 @ 29926;
extern unsigned int sala3 @ 29922;
extern unsigned char ene1_spr @ 29921;
extern unsigned char ene2_spr @ 29920;
extern unsigned char arriba_o_abajo @ 29919;
extern unsigned char hojas @ 29918;

// PARA GENERAR CARTUCHO:
// pantalla comienza en 30000 y las variables de 29999 hacia abajo

// PARA GENERAR CINTA:
// pantalla comienza en 48000 y las variables de 47999 hacia abajo

void main (void)
{
	port_out (254,0); // Ponemos el borde de color negro
	while (1)
	{
		menu();
		juego();
		game_over();
	}
}

signed int juego ()
{
	anim=0;
	anime=0;
	frame=0;
	izquierda=0;
	x=18;
	y=14;
	sala=41;
	vidas=3;
	hojas=0;
	llaves=0;
	crea_mapa_objetos(42, 80); // total de salas, tiles por sala
	cls (7); // Borramos la pantalla
	dibuja_marcador();
	actualiza_marcador();
	dibuja_mapa(sala,6,4,20,80); // sala,x,y,ancho caracteres,tiles por sala
	put_sprite_x16 (sprite_prota_derecha1, x, y);
	while (vidas>0 && hojas<5)
	{
		mueve_prota(); // incluye wait_int()
		// Cambiamos en el escenario los tiles animados
		anima_mapa(sala,6,4,20,80); // sala,x,y,ancho caracteres,tiles por sala
		wait_int();
		anima_enemigos();
		detecta_colisiones();
		wait_int();
	}
	if (hojas==5) final ();
}

signed int final ()
{
	unsigned char z2;
	fade();
	x=4;
	y=4;
	for (z2=0;z2<96;++z2)
	{
		put_sprite_x16 (tiles+mapa_final[z2]*36, x, y);
		++x;
		++x;
		if (x==28)
		{
			x=4;
			++y;
			++y;
		}
	}
	put_sprite_x16 (sprite_prota_izquierda1, 20, 12);
	while(1)
	{
	}	
}

signed int borra_prota()
{
	signed int r1,r2,r3,r4;
	unsigned char xx,yy, mr1, mr2, mr3, mr4;
	xx=x&1;
	yy=y&1;
	r1=sala2+((x-6)/2)+(((y-4)/2)*10);
	r2=sala2+((x-6)/2)+1+(((y-4)/2)*10);
	r3=sala2+((x-6)/2)+((((y-4)/2)+1)*10);
	r4=sala2+((x-6)/2)+1+((((y-4)/2)+1)*10);
	mr1=mapa[r1];
	mr2=mapa[r2];
	mr3=mapa[r3];
	mr4=mapa[r4];
	if (xx)
	{
		if (yy)
		{
			if (mr1<48) put_sprite_x16(tiles+(mr1*36),x-1,y-1);
			else put_sprite_x16(tiles,x-1,y-1);
			if (mr2<48) put_sprite_x16(tiles+(mr2*36),x+1,y-1);	
			else put_sprite_x16(tiles,x+1,y-1);
			if (mr3<48) put_sprite_x16(tiles+(mr3*36),x-1,y+1);
			else put_sprite_x16(tiles,x-1,y+1);
			if (mr4<48) put_sprite_x16(tiles+(mr4*36),x+1,y+1);
			else put_sprite_x16(tiles,x+1,y+1);
		}
		else
		{
			if (mr1<48) put_sprite_x16(tiles+(mr1*36),x-1,y);
			else put_sprite_x16(tiles,x-1,y);
			if (mr2<48) put_sprite_x16(tiles+(mr2*36),x+1,y);	
			else put_sprite_x16(tiles,x+1,y);
		}		
	}
	else
	{
		if (yy)
		{
			if (mr1<48) put_sprite_x16(tiles+(mr1*36),x,y-1);
			else put_sprite_x16(tiles,x,y-1);
			if (mr3<48) put_sprite_x16(tiles+(mr3*36),x,y+1);
			else put_sprite_x16(tiles,x,y+1);
		}
		else
		{
			if (mr1<48) put_sprite_x16(tiles+(mr1*36),x,y);
			else put_sprite_x16(tiles,x,y);		
		}		
	}
}

signed int mueve_prota ()
{
	unsigned char z,mx,my;
	z=0;
	mx=x;
	my=y;
		if (((port_in(64510)&1)==0 || (port_in(63486)&8)==0) && y>0 && pantalla[x+((y-1)*32)]<7 && pantalla[x+1+((y-1)*32)]<7) // Q
		{
			z=1;
			--my;
			arriba_o_abajo=1;
		}
		if (((port_in(65022)&1)==0 || (port_in(63486)&4)==0) && y<22 && pantalla[x+((y+2)*32)]<7 && pantalla[x+1+((y+2)*32)]<7) // A
		{
			z=1;
			++my;
			arriba_o_abajo=0;
		}
		if (((port_in(57342)&1)==0 || (port_in(63486)&2)==0) && x<30 && pantalla[x+2+(my*32)]<7 && pantalla[x+2+((my+1)*32)]<7 && my>3 && my<19) // P
		{
			z=1;
			++mx;
			izquierda=0;
		}
		if (((port_in(57342)&2)==0 || (port_in(63486)&1)==0) && x>0 && pantalla[x-1+(my*32)]<7 && pantalla[x-1+((my+1)*32)]<7 && my>3 && my<19) // O
		{
			z=1;
			--mx;
			izquierda=1;
		}
		// Cambiamos de pantalla si corresponde
		if (mx==25) // Derecha
		{
			x=6;
			mx=6;
			++sala;
			dibuja_mapa(sala,6,4,20,80); // sala,x,y,ancho caracteres,tiles por sala
			ux=x;
			uy=my;
		}
		if (mx==5) // Izquierda
		{
			x=24;
			mx=24;
			--sala;
			dibuja_mapa(sala,6,4,20,80); // sala,x,y,ancho caracteres,tiles por sala
			ux=x;
			uy=my;
		}
		if (my==3) // Arriba
		{
			y=18;
			my=18;
			sala=sala-7;
			dibuja_mapa(sala,6,4,20,80); // sala,x,y,ancho caracteres,tiles por sala
			ux=mx;
			uy=y;
		}
		if (my==19) // Abajo
		{
			y=4;
			my=4;
			sala=sala+7;
			dibuja_mapa(sala,6,4,20,80); // sala,x,y,ancho caracteres,tiles por sala
			ux=mx;
			uy=y;
		}
		// Imprimimos el personaje
		wait_int(); // As evitamos parpadeo al mover
		if (z)
		{
			borra_prota();
			x=mx;
			y=my;
			if (frame==0)
			{
				dibuja_prota();
				frame=1;
				sonido_andar1();
			}
			else
			{
				if (izquierda==0) put_sprite_x16 (sprite_prota_derecha2, x, y);
				else put_sprite_x16 (sprite_prota_izquierda2, x, y);
				frame=0;
				sonido_andar2();
			}
			z=0;
		}
}

signed int game_over ()
{
	unsigned char a;
	for (a=0;a<10;++a)
	{
		port_out (254,18); // Borde color rojo
		port_out (254,18); // Borde color rojo
		wait_int();
		port_out (254,0); // Borde color negro
		port_out (254,0); // Borde color negro
		wait_int();
	}
	fade ();
}

signed int muerte ()
{
	unsigned char a;
	for (a=0;a<5;++a)
	{
		port_out (254,20); // Borde color verde
		wait_int();
		port_out (254,0); // Borde color negro
		wait_int();
	}
	x=ux;
	y=uy;
	--vidas;
	if (vidas>0)
	{
		dibuja_mapa(sala,6,4,20,80);
		actualiza_marcador();
	}
}

signed int detecta_colisiones ()
{
	unsigned char lee1, lee2, lee3, lee4;
	lee1=pantalla[x+(y*32)];
	lee2=pantalla[x+(32+y*32)];
	lee3=pantalla[x+1+(y*32)];
	lee4=pantalla[x+1+(32+y*32)];		
	if (lee1==2 && lee2==2 && lee3==2 && lee4==2) puerta();
	if (lee1==4 || lee2==4 || lee3==4 || lee4==4) muerte();
	if (lee1==5 || lee2==5 || lee3==5 || lee4==5) muerte();
	if (mapa_joyas[sala]==6 && (lee1==6 || lee2==6 || lee3==6 || lee4==6)) recoger_llaves();
	if (mapa_joyas[sala]==3 && (lee1==3 || lee2==3 || lee3==3 || lee4==3)) recoger_hojas();
}

signed int recoger_hojas ()
{
	sonido_rayos();
	mapa_joyas[sala]=33;
	++hojas;
	dibuja_mapa(sala,6,4,20,80);
	actualiza_marcador();
}

signed int recoger_llaves ()
{
	sonido_rayos();
	mapa_joyas[sala]=66;
	++llaves;
	dibuja_mapa(sala,6,4,20,80);
	actualiza_marcador();
}

signed int crea_mapa_objetos (signed int salas, signed int tiless) // total de salas, tiles por sala
{
	signed int z2, z3, sala, sala2;
	sala2=salas*tiless;
	sala=0;
	for (z3=0;z3<sala2;z3=z3+tiless)
	{
		for (z2=z3;z2<z3+tiless;++z2)
		{
			if (mapa[z2]==48) mapa_joyas[sala]=3;
			if (mapa[z2]==50) mapa_joyas[sala]=6;
			if (mapa[z2]==7) mapa_joyas[sala]=8;
		}
		++sala;
	}
}

signed int anima_mapa (signed int sala, signed int x, signed int y, signed int ancho, signed int tiless)
{
	signed int z2, x2, y2;
	x2=x;
	y2=y;
	for (z2=sala2;z2<sala3;++z2)
	{
		switch (mapa[z2])
		{
			case 52:	if (anim==0) put_sprite_x16 (tiles+1872, x2, y2); else put_sprite_x16 (tiles+1908, x2, y2); break;
			case 53:	if (anim==0) put_sprite_x16 (tiles+1908, x2, y2); else put_sprite_x16 (tiles+1872, x2, y2); break;
			case 54:	if (anim==0) put_sprite_x16 (tiles+1944, x2, y2); else put_sprite_x16 (tiles+1980, x2, y2); break;
			case 55:	if (anim==0) put_sprite_x16 (tiles+1980, x2, y2); else put_sprite_x16 (tiles+1944, x2, y2); break;
			case 56:	if (anim==0) put_sprite_x16 (tiles+2016, x2, y2); else put_sprite_x16 (tiles+2052, x2, y2); break;
			case 57:	if (anim==0) put_sprite_x16 (tiles+2052, x2, y2); else put_sprite_x16 (tiles+2016, x2, y2); break;
			default: break;
		}
		++x2;
		++x2;
		if (x2==ancho+x)
		{
			x2=x;
			++y2;
			++y2;
		}
	}
	++anim;
	if (anim==2) anim=0;
}

signed int anima_enemigos ()
{
	// 1 Derecha
	// 2 Arriba
	// 3 izquierda
	// 4 Abajo
	if (ene1_dir>0)
	{
		pantalla [ene1_x+(ene1_y*32)]=0;
		pantalla [ene1_x+1+(ene1_y*32)]=0;
		pantalla [ene1_x+((ene1_y+1)*32)]=0;
		pantalla [ene1_x+1+((ene1_y+1)*32)]=0;
		switch (ene1_dir)
		{
			case 0: break;
			case 1: if (ene1_x<26 && pantalla[ene1_x+2+(ene1_y*32)]==0)
					{
						put_partial1h_sprite_x16 (tiles,ene1_x,ene1_y);
						++ene1_x;
					}
					else ene1_dir=3; break;
			case 2:	if (ene1_y>4 && pantalla[ene1_x+((ene1_y-1)*32)]==0)
					{
						put_partial1v_sprite_x16 (tiles,ene1_x,ene1_y+1);
						--ene1_y;
					}		
					else ene1_dir=4; break;					
			case 3: if (ene1_x>4 && pantalla[ene1_x-1+(ene1_y*32)]==0)
					{
						put_partial1h_sprite_x16 (tiles,ene1_x+1,ene1_y);
						--ene1_x;
					}
					else ene1_dir=1; break;
			case 4:	if (ene1_y<18 && pantalla[ene1_x+((ene1_y+2)*32)]==0)
					{
						put_partial1v_sprite_x16 (tiles,ene1_x,ene1_y);
						++ene1_y;
					}
					else ene1_dir=2; break;
		}
		if (anime==0) put_sprite_x16 (tiles+(ene1_spr*36), ene1_x, ene1_y); else put_sprite_x16 (tiles+((ene1_spr+1)*36), ene1_x, ene1_y);
		pantalla [ene1_x+(ene1_y*32)]=4;
		pantalla [ene1_x+1+(ene1_y*32)]=4;
		pantalla [ene1_x+((ene1_y+1)*32)]=4;
		pantalla [ene1_x+1+((ene1_y+1)*32)]=4;
	}
	if (ene2_dir>0)
	{
		pantalla [ene2_x+(ene2_y*32)]=0;
		pantalla [ene2_x+1+(ene2_y*32)]=0;
		pantalla [ene2_x+((ene2_y+1)*32)]=0;
		pantalla [ene2_x+1+((ene2_y+1)*32)]=0;
		switch (ene2_dir)
		{
			case 0: break;
			case 1: if (ene2_x<26 && pantalla[ene2_x+2+(ene2_y*32)]==0)
					{
						put_partial1h_sprite_x16 (tiles,ene2_x,ene2_y);
						++ene2_x;
					}
					else ene2_dir=3; break;
			case 2:	if (ene2_y>4 && pantalla[ene2_x+((ene2_y-1)*32)]==0)
					{
						put_partial1v_sprite_x16 (tiles,ene2_x,ene2_y+1);
						--ene2_y;
					}		
					else ene2_dir=4; break;					
			case 3: if (ene2_x>4 && pantalla[ene2_x-1+(ene2_y*32)]==0)
					{
						put_partial1h_sprite_x16 (tiles,ene2_x+1,ene2_y);
						--ene2_x;
					}
					else ene2_dir=1; break;
			case 4:	if (ene2_y<18 && pantalla[ene2_x+((ene2_y+2)*32)]==0)
					{
						put_partial1v_sprite_x16 (tiles,ene2_x,ene2_y);
						++ene2_y;
					}
					else ene2_dir=2; break;
		}
		if (anime==0) put_sprite_x16 (tiles+(ene2_spr*36), ene2_x, ene2_y); else put_sprite_x16 (tiles+((ene2_spr+1)*36), ene2_x, ene2_y);
		pantalla [ene2_x+(ene2_y*32)]=5;
		pantalla [ene2_x+1+(ene2_y*32)]=5;
		pantalla [ene2_x+((ene2_y+1)*32)]=5;
		pantalla [ene2_x+1+((ene2_y+1)*32)]=5;
	}
	++anime;
	if (anime==2) anime=0;
}

signed int dibuja_mapa (signed int sala, signed int x, signed int y, signed int ancho, signed int tiless)
{
	signed int z2, x2, y2, frame2, enemigos, cal1,cal2;
	unsigned int direccion;
	unsigned char tile, puerta_cerrada;
	x2=x;
	y2=y;
	sala2=sala*tiless;
	sala3=sala2+tiless;
	enemigos=0;
	ene1_dir=0;
	ene2_dir=0;
	ene1_x=0;
	ene1_y=0;
	ene2_x=0;
	ene2_y=0;
	if (mapa_joyas[sala]==6 || mapa_joyas[sala]==3)	recoger=1;
	else recoger=0;
	if (mapa_joyas[sala]==8) puerta_cerrada=1;
	else puerta_cerrada=0;
	if (puerta_cerrada==1 && llaves>0)
	{
		puerta_cerrada=0;
		mapa_joyas[sala]=88;
		--llaves;
		put_char (numeros+8*llaves, 2, 6);
	}
	for (z2=sala2;z2<sala3;++z2)
	{
		// frame = 7 obstculo
		// frame = 0 traspasable
		// frame = 1 traspasable con decorado
		// frame = 2 puerta abierta
		// frame = 8 puerta cerrada (cambia a 88 en el mapa al ser abierta)
		// frame = 4 enemigo 1
		// frame = 5 enemigo 2
		// frame = 6 llave (cambia a 66 en el mapa al ser cogida)
		// frame = 3 pgina (cambia a 33 en el mapa al ser cogida)
		tile=mapa[z2];
		frame2=7;
		if (tile==0) frame2=0;
		if (tile>0 && tile <4) frame2=1;
		if (tile>3 && tile <6) frame2=2;
		//if (tile>5 && tile<48) frame2=7;
		if (tile==7 && puerta_cerrada==0) frame2=2;
		if (tile==48) frame2=recoger*3;
		if (tile==50) frame2=recoger*6;
		//if (tile>51 && tile<58) frame2=7; // tiles animados
		if (tile>57) // Enemigo
		{
			if (enemigos==0)
			{
				frame2=4; // ENEMIGO 1
				if (tile==58 || tile==60 || tile==62) ene1_dir = 1;
				else ene1_dir = 2;
				ene1_x=x2;
				ene1_y=y2;
				if (ene1_dir==1) ene1_spr=tile;
				else  ene1_spr=tile-1;
			}
			else
			{
				frame2=5; // ENEMIGO 2
				if (tile==58 || tile==60 || tile==62) ene2_dir = 3;
				else ene2_dir = 4;
				ene2_x=x2;
				ene2_y=y2;
				if (ene2_dir==3) ene2_spr=tile;
				else  ene2_spr=tile-1;
			}
			++enemigos;
		}
		cal1=x2+(y2*32);
		cal2=x2+(y2+1)*32;
		pantalla [cal1]=frame2;
		pantalla [1+cal1]=frame2;
		pantalla [cal2]=frame2;
		pantalla [1+cal2]=frame2;
		++x2;
		++x2;
		if (x2==ancho+x)
		{
			x2=x;
			++y2;
			++y2;
		}
	}
	x2=x;
	y2=y;
	wait_int();
	for (z2=sala2;z2<sala3;++z2)
	{
		direccion=mapa[z2]*36;
		if (recoger==0 && (direccion==1728 || direccion==1800)) put_sprite_x16 (tiles, x2, y2);
			else put_sprite_x16 (tiles+direccion, x2, y2);
		if (direccion==252 && puerta_cerrada==0) put_sprite_x16 (tiles+180, x2, y2);
		++x2;
		++x2;
		if (x2==ancho+x)
		{
			x2=x;
			++y2;
			++y2;
		}
	}
}

signed int puerta (void)
{
	unsigned int busca;
	unsigned char leep;

	if (arriba_o_abajo==1) //arriba
	{
		y=16;
		sala=sala-7;
		dibuja_mapa(sala,6,4,20,80); // sala,x,y,ancho caracteres,tiles por sala
	}
	else
	{
		sala=sala+7;
		dibuja_mapa(sala,6,4,20,80); // sala,x,y,ancho caracteres,tiles por sala
		for (busca=4;busca<18;busca=busca+2)
		{
			leep=(pantalla[x+(busca*32)]);
			if (leep==2) y=busca+2;
		}
	}
	ux=x;
	uy=y;
	dibuja_prota();
}

signed int dibuja_marcador (void)
{
	signed int x2, y2;
	put_sprite_x16 (tiles+2304, 4, 2);
	put_sprite_x16 (tiles+2340, 26, 2);
	put_sprite_x16 (tiles+2376, 4, 20);
	put_sprite_x16 (tiles+2412, 26, 20);
	for (x2=6;x2<26;x2=x2+4)
	{
		put_sprite_x16 (tiles+2448, x2, 2);
		put_sprite_x16 (tiles+2484, x2+2, 2);
		put_sprite_x16 (tiles+2520, x2, 20);
		put_sprite_x16 (tiles+2556, x2+2, 20);
	}
	for (y2=4;y2<18;y2=y2+4)
	{
		put_sprite_x16 (tiles+2592, 4, y2);
		put_sprite_x16 (tiles+2628, 4, y2+2);
		put_sprite_x16 (tiles+2664, 26, y2);
		put_sprite_x16 (tiles+2700, 26, y2+2);
	}
	put_sprite_x16 (tiles+1728, 0, 2); // hojas	
	put_sprite_x16 (tiles+1800, 0, 5); // llaves
	put_sprite_x16 (sprite_prota_derecha1, 0, 8); //vidas
}

signed int actualiza_marcador (void)
{
		put_char (numeros+8*hojas, 2, 3);
		put_char (numeros+8*llaves, 2, 6);
		put_char (numeros+8*vidas, 2, 9);
		dibuja_prota();
}

signed int menu (void)
{
	unsigned char a;
	cls(7);
	for (a=0;a<4;++a)
	{
		put_sprite_x16 (tiles_menu+a*36, 12+a*2, 4);
		put_sprite_x16 (tiles_menu+(a+4)*36, 12+a*2, 6);
	}
	x=4;
	y=12;
	for (a=0;a<36;++a)
	{
		put_sprite_x16 (tiles+mapa_final[a]*36, x, y);
		++x;
		++x;
		if (x==28)
		{
			x=4;
			++y;
			++y;
		}
	}
	a=1;
	while(a)
	{
		if ((port_in(32766)&1)==0 || (port_in(63486)&16)==0) a=0; // Tecla de espacio
	}
	fade();
}

signed int dibuja_prota (void)
{
	if (izquierda==1) put_sprite_x16 (sprite_prota_izquierda1, x, y);
	else put_sprite_x16 (sprite_prota_derecha1, x, y);
}

